/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.configuracioneccomerciales.cyberviaje;

import com.rjconsultores.ventaboletos.entidad.ProdTipoptovta;
import com.rjconsultores.ventaboletos.entidad.TipoPuntoVenta;
import com.rjconsultores.ventaboletos.service.ProdTipoptovtaService;
import com.rjconsultores.ventaboletos.service.TipoPuntoVentaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import java.util.Calendar;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Combobox;

/**
 *
 * @author Administrador
 */
@Controller("editarProdTipoptovtaController")
@Scope("prototype")
public class EditarProdTipoptovtaController extends MyGenericForwardComposer {

    @Autowired
    private ProdTipoptovtaService prodTipoptovtaService;
    @Autowired
    private TipoPuntoVentaService tipoPuntoVentaService;
    private List<TipoPuntoVenta> lsTipoPuntoVentas;
    private MyListbox prodTipoPuntoVentaList;
    private Combobox cmbTipoPuntoVenta;
    private ProdTipoptovta prodTipoPuntoVenta;
    private List<ProdTipoptovta> lsProdTipoptovta;
    private static Logger log = Logger.getLogger(EditarProdTipoptovtaController.class);

    public List<TipoPuntoVenta> getLsTipoPuntoVentas() {
        return lsTipoPuntoVentas;
    }

    public void setLsTipoPuntoVentas(List<TipoPuntoVenta> lsTipoPuntoVentas) {
        this.lsTipoPuntoVentas = lsTipoPuntoVentas;
    }

    public ProdTipoptovta getProdTipoPuntoVenta() {
        return prodTipoPuntoVenta;
    }

    public void setProdTipoPuntoVenta(ProdTipoptovta prodTipoPuntoVenta) {
        this.prodTipoPuntoVenta = prodTipoPuntoVenta;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        lsTipoPuntoVentas = tipoPuntoVentaService.obtenerTodos();
        lsProdTipoptovta = (List<ProdTipoptovta>) Executions.getCurrent().getArg().get("lsProdTipoptovta");
        prodTipoPuntoVenta = (ProdTipoptovta) Executions.getCurrent().getArg().get("prodTipoptovta");
        prodTipoPuntoVentaList = (MyListbox) Executions.getCurrent().getArg().get("prodTipoptovtaList");

        super.doAfterCompose(comp);
    }

    public void onClick$btnAdicionar(Event ev) throws Exception {
        cmbTipoPuntoVenta.getValue();
        try {

            if (prodTipoPuntoVenta.getTipoPtovta() == null) {
                Messagebox.show(
                        Labels.getLabel("MSG.Error.combobox"),
                        Labels.getLabel("editarProdTipoptovtaController.winEditarProdTipoPuntoVenta.title"),
                        Messagebox.OK, Messagebox.ERROR);
                return;
            }

            if (prodTipoPuntoVenta.getProdtipoptovtaId() != null) {
                if (registroDuplicado()) {
                    Messagebox.show(
                            Labels.getLabel("editarPricingController.MSG.categoriaExiste"),
                            Labels.getLabel("editarProdTipoptovtaController.winEditarProdTipoPuntoVenta.title"),
                            Messagebox.OK, Messagebox.EXCLAMATION);
                    return;
                }
                prodTipoptovtaService.actualizacion(prodTipoPuntoVenta);
                prodTipoPuntoVentaList.updateItem(prodTipoPuntoVenta);
                lsProdTipoptovta.add(prodTipoPuntoVenta);
            } else {
                if (registroDuplicado()) {
                    Messagebox.show(
                            Labels.getLabel("editarPricingController.MSG.categoriaExiste"),
                            Labels.getLabel("editarProdTipoptovtaController.winEditarProdTipoPuntoVenta.title"),
                            Messagebox.OK, Messagebox.EXCLAMATION);
                    return;
                }
                prodTipoptovtaService.suscribir(prodTipoPuntoVenta);
                prodTipoPuntoVentaList.addItem(prodTipoPuntoVenta);
                lsProdTipoptovta.add(prodTipoPuntoVenta);
            }
            closeWindow();
        } catch (Exception ex) {
            log.error(ex);
        }
    }

    private boolean registroDuplicado() throws InterruptedException {
        for (ProdTipoptovta tv : lsProdTipoptovta) {
            if (!tv.getActivo()){
                continue;
            }
            if (tv.getTipoPtovta().getDesctipo().equals(prodTipoPuntoVenta.getTipoPtovta().getDesctipo())) {
                return true;
            }
        }
        return false;
    }

    public void onClick$btnRemover(Event ev) {
        try {
            Integer resp = Messagebox.show(
                    Labels.getLabel("editarProdTipoptovtaController.MSG.borrarPergunta"),
                    Labels.getLabel("editarProdTipoptovtaController.winEditarProdTipoPuntoVenta.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp.equals(Messagebox.YES)) {
                prodTipoPuntoVenta.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                prodTipoPuntoVenta.setFecmodif(Calendar.getInstance().getTime());
                prodTipoPuntoVenta.setActivo(Boolean.FALSE);

                prodTipoPuntoVentaList.removeItem(prodTipoPuntoVenta);
                prodTipoptovtaService.borrar(prodTipoPuntoVenta);

                Messagebox.show(
                        Labels.getLabel("editarProdTipoptovtaController.MSG.borrarSucesso"),
                        Labels.getLabel("editarProdTipoptovtaController.winEditarProdTipoPuntoVenta.title"),
                        Messagebox.YES, Messagebox.EXCLAMATION);

                closeWindow();
            }

        } catch (Exception ex) {
            log.error(ex);
        }
    }

    /**
     * @return the lsProdTipoptovta
     */
    public List<ProdTipoptovta> getLsProdTipoptovta() {
        return lsProdTipoptovta;
    }

    /**
     * @param lsProdTipoptovta the lsProdTipoptovta to set
     */
    public void setLsProdTipoptovta(List<ProdTipoptovta> lsProdTipoptovta) {
        this.lsProdTipoptovta = lsProdTipoptovta;
    }
}
